#include "XBP.CH"
#include "APPEVENT.CH"

PROCEDURE APPSYS
RETURN

PROCEDURE MAIN
LOCAL nEvent, mp1, mp2, oXbp
LOCAL aTmp                                                  // Statusbar High
LOCAL nStatHigh := 20                                       // Statusbar High
LOCAL nTimeout  := 10
LOCAL oStatbar
LOCAL aoChild   := {}                                       // all Child-obj for resize
LOCAL lExit     := .F.
LOCAL oDlg

   oDlg := XBPDIALOG() :new( APPDESKTOP(),, { 0,0 }, { 800, 600 },, .F. )
   oDlg:taskList := .T.
   oDlg:title := "my StatusBar Test"
   oDlg:close := { || lExit := .T. }
   oDlg:resize := { | aOld, aNew | DialogResize( aOld, aNew, oDlg, aoChild ) }
   oDlg:create()

   aTmp := oDlg:DrawingArea:Currentsize()                   // need for XbpStatusbar

   oStatbar := XB_Statbar():new()
   oStatbar:Create( oDlg,, { 0, 0 }, { aTmp[ 1 ], nStatHigh } )

   AADD( aoChild, oStatbar )                                // add Childs to Array

   oDlg:DrawingArea:SetPosAndSize( { 0, nStatHigh }, { aTmp[ 1 ], aTmp[ 2 ] - nStatHigh } )

   CenterControl(oDlg)
   oDlg:Show()
   SETAPPFOCUS( oDlg )

   oStatbar:SetPanelText("hello world")

   nEvent := xbe_None
   DO WHILE .NOT. lExit
      nEvent := APPEVENT( @mp1, @mp2, @oXbp, nTimeout )     // nTimeout

      DO CASE
         CASE nEvent == xbeP_Keyboard
            IF mp1 == 27
               EXIT
            ENDIF
      ENDCASE

      IF nEvent = xbe_None
         *         EXIT
      ELSE
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDIF
   ENDDO

RETURN

*+
*+
*+    Static Procedure DialogResize()
*+
*+    Called from ( statbar.prg  )   1 - procedure main()
*+
*+
*+
STATIC PROCEDURE DialogResize( aOldSize, aNewSize, oDlg, aoChild )
LOCAL aSize

   IF aOldSize[ 1 ] == 0 .AND. aOldSize[ 2 ] == 0           // New line
      aOldSize := aNewSize                                  // New line
   ELSEIF aNewSize[ 1 ] == 0 .OR. aNewSize[ 2 ] == 0        // New line
      RETURN                                                // New line
      // add "same Size", nothing had happend
   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // New line

   oDlg:DrawingArea:lockUpdate(.T.)

   aSize := aoChild[1]:CurrentSize()
   aSize[1] := aNewSize[ 1 ]
   aoChild[1]:SetSize(aSize)
   aoChild[1]:Resize()

   oDlg:DrawingArea:lockUpdate(.F.)
   oDlg:DrawingArea:invalidateRect()

RETURN

*+ EOF: STATBAR.PRG