#include "inkey.ch"
#include "Appevent.ch"
#include "common.ch"
#include "xbp.ch"
#include "OS.ch"
#include "DLL.ch"

#define ICC_BAR_CLASSES    0x04
#define WS_CHILD           0x40000000
#define WS_VISIBLE         0x10000000
#define WM_USER            0x0400

#define SB_SETTEXT         (WM_USER+1)
#define SB_SETPARTS        (WM_USER+4)
#define SB_SETMINHEIGHT    (WM_USER+8)

#define SBARS_SIZEGRIP                                          0x0100
#define SBARS_TOOLTIPS                                          0x0800

#define GWL_EXSTYLE        -20
#define WS_EX_CONTROLPARENT     0x00010000


#define SWP_NOSIZE 0x0001
#define SWP_NOMOVE 0x0002
#define SWP_NOZORDER 0x0004
#define SWP_NOREDRAW 0x0008
#define SWP_NOACTIVATE 0x0010
#define SWP_FRAMECHANGED 0x0020
#define SWP_SHOWWINDOW 0x0040
#define SWP_HIDEWINDOW 0x0080
#define SWP_NOCOPYBITS 0x0100
#define SWP_NOOWNERZORDER 0x0200
#define SWP_NOSENDCHANGING 0x0400
#define SWP_DRAWFRAME SWP_FRAMECHANGED
#define SWP_NOREPOSITION SWP_NOOWNERZORDER
#define SWP_DEFERERASE 0x2000
#define SWP_ASYNCWINDOWPOS 0x4000



CLASS XB_Statbar FROM XbpStatic

PROTECTED:

   VAR dwSbStyle                                 // Statusbar Style
   VAR dwSbStyleEx                               // Extend Style
   VAR hTheme                                    // Handle Theme visual Style

EXPORTED:
   VAR hXbp
   VAR hStatusBar

   VAR oParent
   VAR aPres
   VAR sizeGrip
   VAR Tooltip

   METHOD Init()
   METHOD Create()
   METHOD Destroy()
   METHOD CreateTheStatusBar()
   METHOD SetPanelText()
   METHOD Resize()

INLINE CLASS METHOD initclass()
*   DllCall( "comctl32.DLL",DLL_STDCALL,"InitCommonControlsEx",{8,ICC_BAR_CLASSES})
RETURN Self

INLINE METHOD Version()
RETURN "0.01"
ENDCLASS

METHOD XB_Statbar:Init(oParent, oOwner, aPos, aSize, aPP, lVisible)
   ::XbpStatic:init(oParent, oOwner, aPos, aSize, aPP, lVisible)

   IF .NOT. EMPTY(oParent)
      ::oParent   := oParent
   ENDIF

   IF EMPTY( aPP )
      * ::aPres := { { XBP_PP_BGCLR, GetApplication():mainForm:drawingArea:SetcolorBG() }, ;
      *              { XBP_PP_FGCLR, GetApplication():mainForm:drawingArea:SetcolorFG() } }
   ELSE
      ::aPres := aPP
   ENDIF

   // PROTECTED
   //
   ::dwSbStyle       := bOr(WS_CHILD,WS_VISIBLE)
   ::dwSbStyleEx     := 0

   // EXPORTED
   //
   ::hStatusBar := 0
   ::sizeGrip := .T.
   ::Tooltip  := .F.

RETURN Self

METHOD XB_Statbar:Create(oParent, oOwner, aPos, aSize, aPP, lVisible)

   IF ::sizeGrip = .T.
      ::dwSbStyle   := bOr(::dwSbStyle,SBARS_SIZEGRIP)
   ENDIF
   IF ::Tooltip  = .T.
*     ::dwSbStyle   := bOr(::dwSbStyle,SBT_TOOLTIPS)   // Version 4.71. Use this style to enable tooltips
      ::dwSbStyle   := bOr(::dwSbStyle,SBARS_TOOLTIPS) // Version 5.80. Identical to SBT_TOOLTIPS. Use this flag for versions 5.00 and later.
   ENDIF

   ::clipChildren := .F.
   ::XbpStatic:Create(oParent, oOwner, aPos, aSize, aPP, lVisible)
   ::hXbp := ::GetHWnd()

   IF .NOT. EMPTY(oParent)
      ::oParent := oParent
   ENDIF

   IF .NOT. EMPTY(aPP)
      ::aPres := aPP
   ENDIF

   ::CreateTheStatusBar()

RETURN Self

METHOD XB_Statbar:Destroy()
RETURN ::XbpStatic:Destroy()

METHOD XB_Statbar:CreateTheStatusBar()
LOCAL nModul, nGetWin

   nGetWin := DllCall( "user32.dll",DLL_STDCALL,"GetWindowLongA", ::hXbp,GWL_EXSTYLE)
   DllCall( "user32.dll",DLL_STDCALL,"SetWindowLongA",::hXbp,GWL_EXSTYLE,bOr(nGetWin,WS_EX_CONTROLPARENT))

   nModul := DllCall( "Kernel32.dll",DLL_STDCALL,"GetModuleHandleA",0)
   ::hStatusBar := DllCall( "user32.dll",DLL_STDCALL,"CreateWindowExA",0,"msctls_statusbar32",0,;
                          bOr(WS_CHILD, WS_VISIBLE),0,0,0,0,;
                          ::hXbp,-1, nModul,0)

   DllCall( "user32.dll",DLL_STDCALL,"SendMessageA",::hStatusBar,SB_SETMINHEIGHT,20,0)
*  DllCall( "user32.dll",DLL_STDCALL,"SendMessageA",::hStatusBar,SB_SETPARTS,2,{180,-1})
   DllCall( "user32.dll",DLL_STDCALL,"SendMessageA",::hStatusBar,SB_SETPARTS,3)
return NIL

METHOD XB_Statbar:SetPanelText(cText, nItem)
DEFAULT nItem TO 1  // Zero-based
   IF !EMPTY(::hStatusBar)
      DllCall( "user32.dll",DLL_STDCALL,"SendMessageA",::hStatusBar,SB_SETTEXT,nItem,cText )
   ENDIF
return NIL

METHOD XB_Statbar:Resize()
LOCAL rc := l2Bin(0)+l2Bin(0)+l2Bin(0)+l2Bin(0)

   DllCall( "user32.dll",DLL_STDCALL,"GetClientRect",::hXbp,@rc)
   DllCall( "user32.dll",DLL_STDCALL,"SetWindowPos",::hStatusbar,0,0,0,Bin2l(SubStr(rc,9,4)),Bin2l(SubStr(rc,13,4)),bOr(SWP_NOACTIVATE,SWP_NOCOPYBITS,SWP_NOREPOSITION,SWP_NOSENDCHANGING,SWP_NOZORDER))
return NIL

*
* eof
*